function A = getmat(name, N, tol)
if nargin <2
    N = 100;
end
if nargin < 3
    tol=1e-8;
end

switch name
    case 'C'
        A=spdiags(ones(N,1), [1], N,N);
        A(N,1) = 1;
    case 'B1'
        c = zeros(N,2);
        c(:,1) = 1;
        c(2:2:N,2) = 0:N/2-1;
        A=spdiags(c, [0,1],N,N);
    case 'D'
        kappa=((1+tol^(1/(2*sqrt(N)))) / (1-tol^(1/(2*sqrt(N)))))^2;
        x = 1+ (kappa-1)*rand(N,1);
        A=diag(x);
    case 'S'
        A=kron(eye(N/2, N/2), [0,1;-1,0]);
    case 'BPM1'
        c = zeros(N,2);
        c(1:2:N,1) = 1;
        c(2:2:N,1) = -1;
        c(2:2:N,2)= 0:N/2-1;
        A=spdiags(c, [0,1],N,N);
    case 'B*'
        y=cos((0:N/2-1)*pi/(N/2-1));
        kappa=((1+tol^(1/(2*sqrt(N/2))))/ (1-tol^(1/(2*sqrt(N/2)))))^2;
        x=1+(y+1)*(kappa-1)/2;
        gamma= (kappa^2+1-x.^2-kappa^2 ./ x.^2).^(1/2);
        ds = zeros(N,2);
        ds(1:2:N,1) = x;
        ds(2:2:N,1) = kappa ./x;
        ds(2:2:N,2) = gamma;
        A = spdiags(ds, [0, 1], N, N);
    otherwise
        error('Nom de matrice inconnu');
end
end
